/*
iBank Javascript
David W. Keith
ibank@pulletsforever.com
*/

// Files
var IBANK = null;
var IBANKUpdater = null
var MEMORIZED_TRANSACTIONSUpdater = null;
var ACCOUNTS = null;
var ACCOUNTSUpdater= null;

// Global Variables
var PREFERENCES = {
	TransactionType: {TypeName: "", Debit: false, Checks: false},
	CurrentAccount: null,
	CurrentTransaction: null,
	BuiltAccountData:[],
	transactionDate: new Date(),
	currentCheck: "",
	Decimal: ".",
	Thousands:",",
	UpdatePeriod: 60,
	NegativeColor: "#BB0600"};

formatCurrency =function (num, currency) {
	if (!currency)
		currency="";
	if(isNaN(num))
		num = "0";
	sign = (num == (num = Math.abs(num)));
	num = Math.floor(num*100+0.50000000001);
	cents = num%100;
	num = Math.floor(num/100).toString();
	if(cents<10)
		cents = "0" + cents;
	for (var i = 0; i < Math.floor((num.length-(1+i))/3); i++)
		num = num.substring(0,num.length-(4*i+3))+PREFERENCES.Thousands+num.substring(num.length-(4*i+3));
	return (((sign)?'':'-')+ currency + num + PREFERENCES.Decimal + cents); 
}

var prettyPrintDate= function (d) {
	var MonthString=new Array(12);
		MonthString[0]="January";
		MonthString[1]="February";
		MonthString[2]="March";
		MonthString[3]="April";
		MonthString[4]="May";
		MonthString[5]="June";
		MonthString[6]="July";
		MonthString[7]="August";
		MonthString[8]="September";
		MonthString[9]="October";
		MonthString[10]="November";
		MonthString[11]="December";
	var date = new Date();
	var thisYear = date.getFullYear(); 
	var thisMonth =  MonthString[date.getMonth()];
	var today = date.getDate();
	var yesterday = today - 1;
	var tomorrow = today + 1;
	var theDate = MonthString[d.getMonth()] + ' ' + d.getDate() + ', ' + d.getFullYear();
	switch(theDate) {
		case thisMonth + ' '+ today + ', ' + thisYear:
			var hours = d.getHours();
			var minutes = d.getMinutes();
			if (hours > 12){
				var am_pm = "PM";
				hours -= 12;
			}
			else{
				am_pm = "AM";
				if (hours == 0)
					hours = 12;
			}
			var time = hours + ':';
			if (minutes < 10)
				time += "0";
			time += minutes + ' ' + am_pm
			return time;
			break;
		case thisMonth + ' '+ yesterday+ ', ' + thisYear:
			return "Yesterday";
			break;
		case thisMonth + ' '+ tomorrow+ ', ' + thisYear:
			return "Tomorrow";
			break;
		default:
			return theDate;
			break;
	}
}

function memorizedTransaction(action, transaction) {
	var MEMORIZED_TRANSACTIONS = null;
	
	checkMemorizedTransactions = function(form) {
		if ($F(form+'Payee') != ""){
			var i=0;
			while (i<MEMORIZED_TRANSACTIONS.length && ($F(form+'Payee').toLowerCase()!=MEMORIZED_TRANSACTIONS[i].Payee.toLowerCase()))
				{i++;}
			if (i<MEMORIZED_TRANSACTIONS.length) {
				$(form+'Payee').value = MEMORIZED_TRANSACTIONS[i].Payee;
				$(form+'Category').value = MEMORIZED_TRANSACTIONS[i].Category;
				$(form+'Amount').value = Number(MEMORIZED_TRANSACTIONS[i].Amount).toFixed(2);
				$(form+'Memo').value = MEMORIZED_TRANSACTIONS[i].Memo;
				$(form+'Type').value = MEMORIZED_TRANSACTIONS[i].Type;
				j=0;
				while ((j < IBANK.TransactionTypes.length) && (MEMORIZED_TRANSACTIONS[i].Type != IBANK.TransactionTypes[j].TypeName))
					{j++;}
				if (IBANK.TransactionTypes[j].Checks)
					$(form+'Check').disabled = false;
					$(form+'Check').value = PREFERENCES.currentCheck;		
				PREFERENCES.TransactionType.Debit = IBANK.TransactionTypes[j].Debit;
			}
			return true;
		}
		return false;
	}

	memorizeTransaction = function(transaction){
		if (transaction.Payee != ""){
			var i=0;
			while ((i<MEMORIZED_TRANSACTIONS.length) && (MEMORIZED_TRANSACTIONS[i].Payee.toLowerCase()!=transaction.Payee.toLowerCase()))
				{i++}
			if (i < MEMORIZED_TRANSACTIONS.length) {
				MEMORIZED_TRANSACTIONS[i].Payee=transaction.Payee;
				MEMORIZED_TRANSACTIONS[i].Category=transaction.Category;
				MEMORIZED_TRANSACTIONS[i].Amount=transaction.Amount;
				MEMORIZED_TRANSACTIONS[i].Memo=transaction.Memo;
				MEMORIZED_TRANSACTIONS[i].Type=transaction.Type;
			}
			else
				MEMORIZED_TRANSACTIONS.push({
					Payee: transaction.Payee,
					Category: transaction.Category,
					Amount: transaction.Amount,
					Memo: transaction.Memo,
					Type: transaction.Type
				});
			if (!IBANK.DemoMode)
				new Ajax.Request("data/MemorizedTransactions.json", {
					method: 'post',
					postBody: Object.toJSON({MemorizedTransactions:MEMORIZED_TRANSACTIONS}),
					onFailure: function(){window.alert("Unable to save memorized transaction to .mac. [Error 03]")}
					}
				);
		}
	}
	doAction = function () {
		switch(action){
			case "check":
				checkMemorizedTransactions(transaction);
				break;
			case "memorize":
				memorizeTransaction(transaction);
				break;
			default:
				break;
		}
	}
	if (MEMORIZED_TRANSACTIONS)
		doAction();
	else
		MEMORIZED_TRANSACTIONSUpdater = new Ajax.PeriodicalUpdater("rawdata","data/MemorizedTransactions.json", {
			method: 'get',
			requestHeaders: {Accept: 'application/json'},
			frequency: PREFERENCES.UpdatePeriod*5,
			decay: 1,
			onSuccess: function(transport){
				MEMORIZED_TRANSACTIONS = transport.responseText.evalJSON(true).MemorizedTransactions;
				doAction();
				},
			onFailure: function(){ window.alert('Unable to read memorized transactions from .mac. [Error 05]');}
			}
		);
}


checkAmount = function(form) {
	if ($F(form+'Amount') != "") {
		var myAmount = Number($F(form+'Amount'));
		if (isNaN(myAmount))
			myAmount = 0;
		else
			if (currentType(form).Debit==true && myAmount > 0)
				myAmount = myAmount * -1;
			else
				if (currentType(form).Debit==false && myAmount < 0)
					myAmount = myAmount * -1;
		$(form+'Amount').value = myAmount.toFixed(2);
	}
}

checkCheck = function(form){
	var checkNumber = Number($F(form+'Check'));
	if (isNaN(checkNumber) || (checkNumber == 0))
		checkNumber = "";
	$(form+'Check').value = checkNumber;
	PREFERENCES.currentCheck = checkNumber;
}

currentType = function(form) {
	return Element.extend(IBANK.TransactionTypes[$(form+"Type").selectedIndex])
}

changeType = function(form) {
	if ($(form+'Amount').value != "" && $(form+'Amount').value != "0.00")
		if (PREFERENCES.TransactionType.Debit != currentType(form).Debit)
			$(form+'Amount').value = ($(form+'Amount').value * -1).toFixed(2);
	if (PREFERENCES.TransactionType.Checks != currentType(form).Checks)
		if (currentType(form).Checks){
			$(form+'Check').value = PREFERENCES.currentCheck;
			$(form+'Check').disabled = false;
		}
		else {
			$(form+'Check').value = "";
			$(form+'Check').disabled = true;
		}
	PREFERENCES.TransactionType = currentType(form);
}


buildCategoryAndType = function(defaultCategory, defaultType, form){
	setDefaults = function() {
		$(form+'Category').value = defaultCategory.escapeHTML();
		$(form+'Type').value = defaultType.escapeHTML();
	};
	if (!IBANK) {
		IBANKUpdater = new Ajax.PeriodicalUpdater("rawdata","data/iBank.json", {
			method: 'get',
			requestHeaders: {Accept: 'application/json'},
			frequency: PREFERENCES.UpdatePeriod*5,
			decay: 1,
			onSuccess: function(transport){
				if (!IBANK) {IBANKUpdater.stop();}
				IBANK = transport.responseText.evalJSON(true);
				$("newCategory").innerHTML="";
				$("transactionCategory").innerHTML="";
				for (category=0; category<IBANK.Categories.length; category++){
					newcategoryelement = document.createElement('option');
					newcategoryelement.text = IBANK.Categories[category].escapeHTML();
					$("newCategory").add(newcategoryelement, null);
					transactioncategoryelemenet = document.createElement('option');
					transactioncategoryelemenet.text = IBANK.Categories[category].escapeHTML();
					$("transactionCategory").add(transactioncategoryelemenet, null);
				};
				$("newType").innerHTML="";
				$("transactionType").innerHTML="";
				for (type=0; type<IBANK.TransactionTypes.length; type++){
					newtypeelement = document.createElement('option');
					newtypeelement.text = IBANK.TransactionTypes[type].TypeName.escapeHTML();
					$("newType").add(newtypeelement, null);
					transactiontypeelemenet = document.createElement('option');
					transactiontypeelemenet.text = IBANK.TransactionTypes[type].TypeName.escapeHTML();
					$("transactionType").add(transactiontypeelemenet, null);
				};
				setDefaults();
			},
			onFailure: function(){ window.alert('Unable to read iBank data from .mac. [Error 04]');}
		});
	}
	else {
		IBANKUpdater.stop();
		setDefaults();
	};
}


var setupDateEntry = function(form) {
	$(form+'Day').value = PREFERENCES.transactionDate.getDate();
	$(form+'Month').value = PREFERENCES.transactionDate.getMonth();
	$(form+'Year').value = PREFERENCES.transactionDate.getFullYear();
}

var updateDate = function(form) {
	PREFERENCES.transactionDate.setFullYear($F(form+'Year'),$F(form+'Month'),$F(form+'Day'));
	$(form+'Date').innerHTML = prettyPrintDate(PREFERENCES.transactionDate);
}

var writeAccountData = function(account){
	var transactionSortFunction = function(a, b) {
		var aDate = new Date(a.TransactionDate);
		var bDate = new Date(b.TransactionDate);
		if (aDate < bDate)
			return -1;
		else if (aDate > bDate)
			return 1
		else
			return 0;
	}
	if (!PREFERENCES.BuiltAccountData[account]){
		if (ACCOUNTS[account].Transactions.length > 0){
			ACCOUNTS[account].Transactions.sort(transactionSortFunction);
			for(transaction=0; transaction<ACCOUNTS[account].Transactions.length; transaction++){
				new Insertion.Top('account'+account, transactionToHTML(account, transaction));
			}
		}
		else
			new Insertion.Top('account'+account, "<li id='no_transactions_found_in_account_"+account+"'>No transactions found.</li>");
		PREFERENCES.BuiltAccountData[account] = true;
	}
}

var rewriteAccountData = function (account) {
	$("account"+account).innerHTML = '<li class="group" id="transactionListBalanceLI'+account+'">Balance:<div class="transactionListBalance" id="transactionListBalance'+account+'"></div></li>';
	writeNewBalance(account);
	PREFERENCES.BuiltAccountData[account] = false;
	writeAccountData(account);
}

var transactionToHTML = function(account, transaction) {
	var currentTransaction = ACCOUNTS[account].Transactions[transaction];
	var transactionHTML = '';
	switch(currentTransaction.State){
		case -2:
			transactionHTML = '<li class="lockedTransaction">';
			break;
		case -1:
			transactionHTML = '<li class="deletedTransaction">';
			break;
		case 0:
			transactionHTML = '<li class="existingTransaction">';
			break;
		default:
			transactionHTML = '<li class="newTransaction">';
			transactionHTML += '<a href=\"#editTransaction\" onclick="PREFERENCES.CurrentTransaction = '+transaction+';setupEditTransaction('+account+','+transaction+');">';
			break;
	}
	var amount = new Number(currentTransaction.Amount);
	if (amount < 0)
		transactionHTML += '<div class="amount" style="color:'+PREFERENCES.NegativeColor+'">'+formatCurrency(amount, ACCOUNTS[account].CurrencySymbol)+'</div>';
	else
		transactionHTML += '<div class="amount">'+formatCurrency(amount, ACCOUNTS[account].CurrencySymbol)+'</div>';
	transactionHTML += '<div class="payee">'+currentTransaction.Payee.escapeHTML()+'</div>';
	transactionHTML += '<div class="transactionDate">'+prettyPrintDate(theDate(currentTransaction.TransactionDate))+'</div>';
	transactionHTML += '<div class="type">'+currentTransaction.Type.escapeHTML()+' '+currentTransaction.CheckNumber+' - <span class="category">'+currentTransaction.Category.escapeHTML()+'</span></div>';
	transactionHTML += '<div class="memo">'+currentTransaction.Memo.escapeHTML()+'&nbsp;</div>';
	switch(ACCOUNTS[account].Transactions[transaction].State){
		case -2:
			transactionHTML += '</div></li>';
			break;
		case -1:
			transactionHTML += '</div></li>';
			break;
		case 0:
			transactionHTML += '</div></li>';
			break;
		default:
			transactionHTML += '</div></a></li>';
			break;
	}
	return transactionHTML;
}

// Add Transaciton only
var setupAddTransaction = function(){
	buildCategoryAndType("", "POS", "new");
	PREFERENCES.transactionDate = new Date();
	PREFERENCES.currentCheck = "";
	PREFERENCES.TransactionType.Checks = false;
	$('newDate').innerHTML = prettyPrintDate(PREFERENCES.transactionDate);
}


var addTransaction = function(account) {
	if ($F('newAmount') == "0.00" || $F('newAmount') == "")
		window.alert("Amount is required for new transactions.");
	else {
		$('pageTitle').style.display = "none";
		$('progressIndicator').style.display = "block";
		var currentTransaction = {
			Payee: $F('newPayee'),
			Category: $F('newCategory'),
			Amount: $F('newAmount'),
			Memo: $F('newMemo'),
			Type: $F('newType'),
			CheckNumber: $F('newCheck'),
			TransactionDate: PREFERENCES.transactionDate.toUTCString(),
			State: 1,
			ID: ""};
		//if (currentType("new").Checks >= 0)
		//	currentType("new").Checks += 1;
		ACCOUNTS[account].Balance = Number(ACCOUNTS[account].Balance) + Number($F('newAmount'));
		ACCOUNTS[account].Transactions.push(currentTransaction);
		saveAccounts();
		rewriteAccountData(account);
		memorizedTransaction("memorize", currentTransaction);
		$("addTransaction").removeAttribute("selected");
		history.back();
		$("addTransaction").reset();
		}
}


saveAccounts = function(){
	$('pageTitle').style.display = "none";
	$('progressIndicator').style.display = "block";
	if (IBANK.DemoMode){
		$('pageTitle').style.display = "block";
		$('progressIndicator').style.display = "none";
		IBANKUpdater.stop();
		ACCOUNTSUpdater.stop();
		MEMORIZED_TRANSACTIONSUpdater.stop();
	}
	else
		new Ajax.Request("data/Accounts.json", {
			method: 'post',
			postBody: Object.toJSON({AccountList:ACCOUNTS}),
			onSuccess: function(){
				$('pageTitle').style.display = "block";
				$('progressIndicator').style.display = "none";
				IBANKUpdater.start();
			},
			onFailure: function(){ 
				var tryAgain=confirm("Saving transaction to .mac failed. Try again? [Error 06]")
				if (tryAgain == true)
					saveAccounts();
				else {
					$('progressIndicator').style.display = "none";
					$('pageTitle').style.display = "block";
				}
			}
		}
		);	
}

getAccountData = function() {
	ACCOUNTSUpdater = new Ajax.PeriodicalUpdater("rawdata","data/Accounts.json", {
	  	method: 'get',
		requestHeaders: {Accept: 'application/json'},
		frequency: PREFERENCES.UpdatePeriod,
		decay: 1,
	  	onSuccess: function(transport){
			ACCOUNTS = transport.responseText.evalJSON(true).AccountList;
			if (ACCOUNTS.length > 0) {
				var accountListHTML = "";
				for (account=0; account<ACCOUNTS.length; account++){
					var eachAccount = '<li><a href="#account'+account+'" onclick="setAccount('+account+');">';
					eachAccount += '<div class="accountBalance" id="balance'+account+'"';
					var eachBalance;
					if (ACCOUNTS[account].Balance < 0){
					 	eachAccount +=' style="color:'+PREFERENCES.NegativeColor+'">'+formatCurrency(ACCOUNTS[account].Balance, ACCOUNTS[account].CurrencySymbol)+'</div>';
						eachBalance = '<li class="group" id="transactionListBalanceLI'+account+'">Balance:<div class="transactionListBalance" id="transactionListBalance'+account+'" style="color:'+PREFERENCES.NegativeColor+'">'+formatCurrency(ACCOUNTS[account].Balance, ACCOUNTS[account].CurrencySymbol)+'</div></li>';
					}
					else {
						eachAccount += '>'+formatCurrency(ACCOUNTS[account].Balance, ACCOUNTS[account].CurrencySymbol)+'</div>';
						eachBalance = '<li class="group" id="transactionListBalanceLI'+account+'">Balance:<div class="transactionListBalance" id="transactionListBalance'+account+'">'+formatCurrency(ACCOUNTS[account].Balance, ACCOUNTS[account].CurrencySymbol)+'</div></li>';
					}
					var thisAccountType = ACCOUNTS[account].Type;
					if (thisAccountType>9){thisAccountType=3};
					eachAccount += '<div class="accountName"><img src="images/accounticons/'+thisAccountType+'.png" height="20" width="20"> ';
					eachAccount += ACCOUNTS[account].AccountName.escapeHTML()+'</div></a></li>';
					accountListHTML += eachAccount;
					if ($('account'+account)){
						if (PREFERENCES.BuiltAccountData[account])
							rewriteAccountData(account);
						}
					else{
						new Insertion.After('iBank', '<ul id="account'+account+'" title="'+ACCOUNTS[account].AccountName.escapeHTML()+'" extraLabel="+" extraHref="#addTransaction">'+eachBalance+'</ul>');
						PREFERENCES.BuiltAccountData[account]=false;
					}
				};
				$("iBank").innerHTML = accountListHTML;
			}
			else
				new Insertion.Top('iBank', '<li>Accounts have not been synced.</li><li>On your Mac open iBank and select "Sync with .mac" from the File menu. [Error 01]</li>');
		},
		onFailure: function(){ new Insertion.Top('iBank', '<li>Unable to read account data from .mac. Refresh the page in Safari to try again. [Error 02]</li>');}
	});
}

// Edit Transaction Specific
setupEditTransaction = function (account, transaction){
	scrollTo(0, 1);
	var currentTransaction = ACCOUNTS[account].Transactions[transaction];
	buildCategoryAndType(currentTransaction.Category, currentTransaction.Type, "transaction")
	$('transactionDate').innerHTML = prettyPrintDate(theDate(currentTransaction.TransactionDate));
	$('transactionPayee').value = currentTransaction.Payee;
	$('transactionAmount').value = currentTransaction.Amount;
	$('transactionMemo').value = currentTransaction.Memo;
	$('transactionCheck').value = currentTransaction.CheckNumber;
	if (currentTransaction.CheckNumber){
		PREFERENCES.TransactionType.Checks = true;
		PREFERENCES.currentCheck = currentTransaction.CheckNumber;
		$('transactionCheck').disabled = false;
	}
}

saveTransaction = function(account, transaction) {
	$('progressIndicator').style.display = "block";
	$('deleteConfirmation').style.display='none';
	var currentTransaction = ACCOUNTS[account].Transactions[transaction];
	ACCOUNTS[account].Balance +=  $F('transactionAmount') - currentTransaction.Amount;
	currentTransaction.Payee = $F('transactionPayee');
	currentTransaction.Category = $F('transactionCategory');
	currentTransaction.Amount= $F('transactionAmount');
	currentTransaction.Memo= $F('transactionMemo');
	currentTransaction.Type= $F('transactionType');
	currentTransaction.CheckNumber= $F('transactionCheck');
	currentTransaction.TransactionDate= PREFERENCES.transactionDate.toUTCString();
	if (currentTransaction.State<1)
		currentTransaction.State = 2;
	$("editTransaction").removeAttribute("selected");
	history.back();
	rewriteAccountData(account);
	memorizedTransaction("memorize", ACCOUNTS[account].Transactions[transaction]);
	saveAccounts();
}

deleteTransaction = function(account, transaction) {
	$('deleteConfirmation').style.display='none';
	ACCOUNTS[account].Balance -= ACCOUNTS[account].Transactions[transaction].Amount;
	if (ACCOUNTS[account].Transactions[transaction].State == 1)
		ACCOUNTS[account].Transactions.splice(transaction, 1);
	else
		ACCOUNTS[account].Transactions[transaction].State = -1;
	rewriteAccountData(account);
	saveAccounts();
	$("editTransaction").removeAttribute("selected");
}



var writeNewBalance = function(account){
	if (ACCOUNTS[account].Balance < 0) {
		$('balance'+account).innerHTML = formatCurrency(ACCOUNTS[account].Balance, ACCOUNTS[account].CurrencySymbol).fontcolor(PREFERENCES.NegativeColor);
		$('transactionListBalance'+account).innerHTML = formatCurrency(ACCOUNTS[account].Balance, ACCOUNTS[account].CurrencySymbol).fontcolor(PREFERENCES.NegativeColor);
	}
	else {
		$('balance'+account).innerHTML = formatCurrency(ACCOUNTS[account].Balance, ACCOUNTS[account].CurrencySymbol).fontcolor("black");
		$('transactionListBalance'+account).innerHTML = formatCurrency(ACCOUNTS[account].Balance, ACCOUNTS[account].CurrencySymbol).fontcolor("white");
	}
}

var theDate = function(dateString) {
	var newDate = new Date(dateString);
	PREFERENCES.transactionDate = newDate;
	return newDate;
}

var setAccount = function(account) {
	PREFERENCES.CurrentAccount = account;
	writeAccountData(account);
}

addEventListener('load', getAccountData, false);